From 4a8dc4c7664ab9ec3a4cce15f2f20e1baf19a0d0 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 9 Nov 2012 10:56:42 -0500
Subject: [PATCH] Removed CA, KRA, OCSP, TKS theme packages.

The build scripts and spec files have been updated to no longer
create the theme packages for CA, KRA, OCSP, and TKS.

Ticket #407
---
 dogtag/CMakeLists.txt                     |   5 -
 scripts/build_dogtag_pki                  |   6 +-
 scripts/compose_dogtag_pki_theme_packages |   2 +-
 specs/dogtag-pki-theme.spec               | 162 +++++++-----------------------
 specs/dogtag-pki.spec                     |   9 +-
 specs/ipa-pki-theme.spec                  |  44 +++-----
 specs/pki-core.spec                       |   9 +-
 7 files changed, 59 insertions(+), 178 deletions(-)

diff --git a/dogtag/CMakeLists.txt b/dogtag/CMakeLists.txt
index d83f915914e18cf1bde3e4718d568fd67f062525..aa4f2fc839ed194df1fe664673775a23ba848a3c 100644
--- a/dogtag/CMakeLists.txt
+++ b/dogtag/CMakeLists.txt
@@ -2,15 +2,10 @@ project(dogtag)
 
 if (APPLICATION_FLAVOR_IPA_PKI_THEME)
     add_subdirectory(common-ui)
-    add_subdirectory(ca-ui)
 endif (APPLICATION_FLAVOR_IPA_PKI_THEME)
 if (APPLICATION_FLAVOR_DOGTAG_PKI_THEME)
     add_subdirectory(common-ui)
-    add_subdirectory(ca-ui)
-    add_subdirectory(kra-ui)
-    add_subdirectory(ocsp-ui)
     add_subdirectory(ra-ui)
-    add_subdirectory(tks-ui)
     add_subdirectory(tps-ui)
     add_subdirectory(console-ui)
 endif (APPLICATION_FLAVOR_DOGTAG_PKI_THEME)
diff --git a/scripts/build_dogtag_pki b/scripts/build_dogtag_pki
index 5a63a692fdaf46bfbde46c9a40fe6e6663b86614..91acc3b0a27edcf933101bf8c49e13f0112fda78 100755
--- a/scripts/build_dogtag_pki
+++ b/scripts/build_dogtag_pki
@@ -118,11 +118,7 @@ PKI_CONSOLE_PACKAGES_DIR="${PKI_PWD}/packages.console"
 
 # Establish PKI theme package names
 PKI_SERVER_THEME=${PKI_FLAVOR}-pki-server-theme${RPM_EXT}
-PKI_CA_THEME=${PKI_FLAVOR}-pki-ca-theme${RPM_EXT}
-PKI_KRA_THEME=${PKI_FLAVOR}-pki-kra-theme${RPM_EXT}
-PKI_OCSP_THEME=${PKI_FLAVOR}-pki-ocsp-theme${RPM_EXT}
 PKI_RA_THEME=${PKI_FLAVOR}-pki-ra-theme${RPM_EXT}
-PKI_TKS_THEME=${PKI_FLAVOR}-pki-tks-theme${RPM_EXT}
 PKI_TPS_THEME=${PKI_FLAVOR}-pki-tps-theme${RPM_EXT}
 PKI_CONSOLE_THEME=${PKI_FLAVOR}-pki-console-theme${RPM_EXT}
 
@@ -160,7 +156,7 @@ cd ${PKI_PWD}
 ${PKI_COMPOSE_SCRIPTS_DIR}/${COMPOSE_DOGTAG_PKI_THEME_PACKAGES} rpms
 mv ${PKI_PACKAGES_DIR} ${PKI_DOGTAG_THEME_PACKAGES_DIR}
 cd ${PKI_DOGTAG_THEME_PACKAGES_DIR}/${RPM_DIR}/${NOARCH}
-${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SERVER_THEME} ${PKI_CA_THEME} ${PKI_KRA_THEME} ${PKI_OCSP_THEME} ${PKI_RA_THEME} ${PKI_TKS_THEME} ${PKI_TPS_THEME} ${PKI_CONSOLE_THEME}
+${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SERVER_THEME} ${PKI_RA_THEME} ${PKI_TPS_THEME} ${PKI_CONSOLE_THEME}
 
 # Compose and install 'pki-core' packages
 cd ${PKI_PWD}
diff --git a/scripts/compose_dogtag_pki_theme_packages b/scripts/compose_dogtag_pki_theme_packages
index 76ba2a1c0fd82fcfe65129fc31352866131b1023..a9c6b189c282eddfa256a4595661586ffd02f8b8 100755
--- a/scripts/compose_dogtag_pki_theme_packages
+++ b/scripts/compose_dogtag_pki_theme_packages
@@ -39,7 +39,7 @@ DOGTAG_PKI_THEME_VERSION="10.0.0.b2"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${DOGTAG_PKI_THEME}.spec"
-PKI_COMPONENT_LIST="test common-ui ca-ui kra-ui ocsp-ui tks-ui ra-ui tps-ui console-ui"
+PKI_COMPONENT_LIST="test common-ui ra-ui tps-ui console-ui"
 
 
 ##
diff --git a/specs/dogtag-pki-theme.spec b/specs/dogtag-pki-theme.spec
index ac4384ef7fd1f6945df24a5dc9063e6e8382294e..489f26c8aff5fb7a77a211fba9042acf7501a98c 100644
--- a/specs/dogtag-pki-theme.spec
+++ b/specs/dogtag-pki-theme.spec
@@ -7,7 +7,7 @@
 
 Name:             dogtag-pki-theme
 Version:          10.0.0
-Release:          %{?relprefix}5%{?prerel}%{?dist}
+Release:          %{?relprefix}6%{?prerel}%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -67,106 +67,61 @@ Group:            System Environment/Base
 Conflicts:        redhat-pki-server-theme
 Conflicts:        redhat-pki-common-theme
 Conflicts:        redhat-pki-common-ui
+Conflicts:        redhat-pki-ca-theme
+Conflicts:        redhat-pki-ca-ui
+Conflicts:        redhat-pki-kra-theme
+Conflicts:        redhat-pki-kra-ui
+Conflicts:        redhat-pki-ocsp-theme
+Conflicts:        redhat-pki-ocsp-ui
+Conflicts:        redhat-pki-tks-theme
+Conflicts:        redhat-pki-tks-ui
 
 # EPEL version of Dogtag "theme" ALWAYS replaces ALL versions of IPA "theme"
 Obsoletes:        ipa-pki-server-theme <= 9999
 Obsoletes:        ipa-pki-common-theme <= 9999
+Obsoletes:        ipa-pki-ca-theme <= 9999
+Obsoletes:        ipa-pki-kra-theme <= 9999
+
 Provides:         ipa-pki-server-theme = %{version}-%{release}
 Provides:         ipa-pki-common-theme = %{version}-%{release}
+Provides:         ipa-pki-ca-theme = %{version}-%{release}
+Provides:         ipa-pki-kra-theme = %{version}-%{release}
 %endif
 
 Obsoletes:        dogtag-pki-common-theme
 Obsoletes:        dogtag-pki-common-ui
+Obsoletes:        dogtag-pki-ca-theme
+Obsoletes:        dogtag-pki-ca-ui
+Obsoletes:        dogtag-pki-kra-theme
+Obsoletes:        dogtag-pki-kra-ui
+Obsoletes:        dogtag-pki-ocsp-theme
+Obsoletes:        dogtag-pki-ocsp-ui
+Obsoletes:        dogtag-pki-tks-theme
+Obsoletes:        dogtag-pki-tks-ui
 
 Provides:         pki-server-theme = %{version}-%{release}
 Provides:         pki-common-theme = %{version}-%{release}
 Provides:         pki-common-ui = %{version}-%{release}
 
-%description -n   dogtag-pki-server-theme
-This PKI Server Framework User Interface contains
-the Dogtag textual and graphical user interface for the PKI Server Framework.
-
-This package is used by the Dogtag Certificate System.
-
-%{overview}
-
-
-%package -n       dogtag-pki-ca-theme
-Summary:          Certificate System - Certificate Authority User Interface
-Group:            System Environment/Base
-
-Requires:         dogtag-pki-server-theme = %{version}-%{release}
-
-%if 0%{?rhel}
-# EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
-Conflicts:        redhat-pki-ca-theme
-Conflicts:        redhat-pki-ca-ui
-
-# EPEL version of Dogtag "theme" ALWAYS replaces ALL versions of IPA "theme"
-Obsoletes:        ipa-pki-ca-theme <= 9999
-Provides:         ipa-pki-ca-theme = %{version}-%{release}
-%endif
-
-Obsoletes:        dogtag-pki-ca-ui <= 9
-
+Provides:         dogtag-pki-ca-theme = %{version}-%{release}
 Provides:         pki-ca-theme = %{version}-%{release}
 Provides:         pki-ca-ui = %{version}-%{release}
 
-%description -n   dogtag-pki-ca-theme
-This Certificate Authority (CA) User Interface contains
-the Dogtag textual and graphical user interface for the CA.
-
-This package is used by the Dogtag Certificate System.
-
-%{overview}
-
-
-%package -n       dogtag-pki-kra-theme
-Summary:          Certificate System - Data Recovery Manager User Interface
-Group:            System Environment/Base
-
-Requires:         dogtag-pki-server-theme = %{version}-%{release}
-
-%if 0%{?rhel}
-# EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
-Conflicts:        redhat-pki-kra-theme
-Conflicts:        redhat-pki-kra-ui
-%endif
-
-Obsoletes:        dogtag-pki-kra-ui <= 9
-
+Provides:         dogtag-pki-kra-theme = %{version}-%{release}
 Provides:         pki-kra-theme = %{version}-%{release}
 Provides:         pki-kra-ui = %{version}-%{release}
 
-%description -n   dogtag-pki-kra-theme
-This Data Recovery Manager (DRM) User Interface contains
-the Dogtag textual and graphical user interface for the DRM.
-
-This package is used by the Dogtag Certificate System.
-
-%{overview}
-
-
-%package -n       dogtag-pki-ocsp-theme
-Summary:          Certificate System - Online Certificate Status Protocol Manager User Interface
-Group:            System Environment/Base
-
-Requires:         dogtag-pki-server-theme = %{version}-%{release}
-
-%if 0%{?rhel}
-# EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
-Conflicts:        redhat-pki-ocsp-theme
-Conflicts:        redhat-pki-ocsp-ui
-%endif
-
-Obsoletes:        dogtag-pki-ocsp-ui <= 9
-
+Provides:         dogtag-pki-ocsp-theme = %{version}-%{release}
 Provides:         pki-ocsp-theme = %{version}-%{release}
 Provides:         pki-ocsp-ui = %{version}-%{release}
 
-%description -n   dogtag-pki-ocsp-theme
-This Online Certificate Status Protocol (OCSP) Manager User Interface contains
-the Dogtag textual and graphical user interface for the OCSP Manager.
+Provides:         dogtag-pki-tks-theme = %{version}-%{release}
+Provides:         pki-tks-theme = %{version}-%{release}
+Provides:         pki-tks-ui = %{version}-%{release}
+
+%description -n   dogtag-pki-server-theme
+This PKI Server Framework User Interface contains
+the Dogtag textual and graphical user interface for the PKI Server Framework.
 
 This package is used by the Dogtag Certificate System.
 
@@ -199,32 +154,6 @@ This package is used by the Dogtag Certificate System.
 %{overview}
 
 
-%package -n       dogtag-pki-tks-theme
-Summary:          Certificate System - Token Key Service User Interface
-Group:            System Environment/Base
-
-Requires:         dogtag-pki-server-theme = %{version}-%{release}
-
-%if 0%{?rhel}
-# EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
-Conflicts:        redhat-pki-tks-theme
-Conflicts:        redhat-pki-tks-ui
-%endif
-
-Obsoletes:        dogtag-pki-tks-ui <= 9
-
-Provides:         pki-tks-theme = %{version}-%{release}
-Provides:         pki-tks-ui = %{version}-%{release}
-
-%description -n   dogtag-pki-tks-theme
-This Token Key Service (TKS) User Interface contains
-the Dogtag textual and graphical user interface for the TKS.
-
-This package is used by the Dogtag Certificate System.
-
-%{overview}
-
-
 %package -n       dogtag-pki-tps-theme
 Summary:          Certificate System - Token Processing System User Interface
 Group:            System Environment/Base
@@ -325,24 +254,6 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 %{_datadir}/pki/common-ui/
 
 
-%files -n dogtag-pki-ca-theme
-%defattr(-,root,root,-)
-%doc dogtag/ca-ui/LICENSE
-%{_datadir}/pki/ca-ui/
-
-
-%files -n dogtag-pki-kra-theme
-%defattr(-,root,root,-)
-%doc dogtag/kra-ui/LICENSE
-%{_datadir}/pki/kra-ui/
-
-
-%files -n dogtag-pki-ocsp-theme
-%defattr(-,root,root,-)
-%doc dogtag/ocsp-ui/LICENSE
-%{_datadir}/pki/ocsp-ui/
-
-
 %files -n dogtag-pki-ra-theme
 %defattr(-,root,root,-)
 %doc dogtag/ra-ui/LICENSE
@@ -350,12 +261,6 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 %{_datadir}/pki/ra-ui/
 
 
-%files -n dogtag-pki-tks-theme
-%defattr(-,root,root,-)
-%doc dogtag/tks-ui/LICENSE
-%{_datadir}/pki/tks-ui/
-
-
 %files -n dogtag-pki-tps-theme
 %defattr(-,root,root,-)
 %doc dogtag/tps-ui/LICENSE
@@ -370,6 +275,9 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 
 
 %changelog
+* Fri Nov 9 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.6.b2
+- Removed Dogtag CA, KRA, OCSP, TKS theme packages.
+
 * Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.b2
 - Renamed dogtag-pki-common-theme to dogtag-pki-server-theme.
 - Fixed theme package dependencies.
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 94a76339bc12ece4a7680fb295699bdfac29c5f1..892a38fba503ffb05f50e5712d8a5d57a67162e0 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -8,7 +8,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          10.0.0
-Release:          %{?relprefix}14%{?prerel}%{?dist}
+Release:          %{?relprefix}15%{?prerel}%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -84,13 +84,9 @@ Requires:         jss-javadoc >= %{jss_version}
 
 # Make certain that this 'meta' package requires the latest version(s)
 # of ALL Dogtag PKI theme packages
-Requires:         dogtag-pki-ca-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-server-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-console-theme >= %{dogtag_pki_theme_version}
-Requires:         dogtag-pki-kra-theme >= %{dogtag_pki_theme_version}
-Requires:         dogtag-pki-ocsp-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-ra-theme >= %{dogtag_pki_theme_version}
-Requires:         dogtag-pki-tks-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-tps-theme >= %{dogtag_pki_theme_version}
 
 # Make certain that this 'meta' package requires the latest version(s)
@@ -198,6 +194,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Fri Nov 9 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.15.b2
+- Removed Dogtag CA, KRA, OCSP, TKS theme packages.
+
 * Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.14.b2
 - Renamed dogtag-pki-common-theme to dogtag-pki-server-theme.
 
diff --git a/specs/ipa-pki-theme.spec b/specs/ipa-pki-theme.spec
index bdb15a3bdc05d02e3b79a53005df0373a6c471e2..bd0740f80331ab44bc0544762b3f18506c6db34b 100644
--- a/specs/ipa-pki-theme.spec
+++ b/specs/ipa-pki-theme.spec
@@ -7,7 +7,7 @@
 
 Name:             ipa-pki-theme
 Version:          10.0.0
-Release:          %{?relprefix}4%{?prerel}%{?dist}
+Release:          %{?relprefix}5%{?prerel}%{?dist}
 Summary:          Certificate System - IPA PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -59,17 +59,27 @@ Group:            System Environment/Base
 Conflicts:        dogtag-pki-server-theme
 Conflicts:        dogtag-pki-common-theme
 Conflicts:        dogtag-pki-common-ui
+Conflicts:        dogtag-pki-ca-theme
+Conflicts:        dogtag-pki-ca-ui
+
 Conflicts:        redhat-pki-server-theme
 Conflicts:        redhat-pki-common-theme
 Conflicts:        redhat-pki-common-ui
+Conflicts:        redhat-pki-ca-theme
+Conflicts:        redhat-pki-ca-ui
 
 Obsoletes:        ipa-pki-common-theme
 Obsoletes:        ipa-pki-common-ui
+Obsoletes:        ipa-pki-ca-theme
 
 Provides:         pki-server-theme = %{version}-%{release}
 Provides:         pki-common-theme = %{version}-%{release}
 Provides:         pki-common-ui = %{version}-%{release}
 
+Provides:         ipa-pki-ca-theme = %{version}-%{release}
+Provides:         pki-ca-theme = %{version}-%{release}
+Provides:         pki-ca-ui = %{version}-%{release}
+
 %description -n   ipa-pki-server-theme
 This PKI Server Framework User Interface contains
 NO textual or graphical user interface for the PKI Server Framework.
@@ -79,29 +89,6 @@ This package is used by the Certificate System utilized by IPA.
 %{overview}
 
 
-%package -n       ipa-pki-ca-theme
-Summary:          Certificate System - Certificate Authority User Interface
-Group:            System Environment/Base
-
-Requires:         ipa-pki-server-theme = %{version}-%{release}
-
-Conflicts:        dogtag-pki-ca-theme
-Conflicts:        dogtag-pki-ca-ui
-Conflicts:        redhat-pki-ca-theme
-Conflicts:        redhat-pki-ca-ui
-
-Provides:         pki-ca-theme = %{version}-%{release}
-Provides:         pki-ca-ui = %{version}-%{release}
-
-%description -n   ipa-pki-ca-theme
-This Certificate Authority (CA) User Interface contains
-NO textual or graphical user interface for the CA.
-
-This package is used by the Certificate System utilized by IPA.
-
-%{overview}
-
-
 %prep
 
 
@@ -134,13 +121,10 @@ cd build
 %{_datadir}/pki/common-ui/
 
 
-%files -n ipa-pki-ca-theme
-%defattr(-,root,root,-)
-%doc dogtag/ca-ui/LICENSE
-%{_datadir}/pki/ca-ui/
-
-
 %changelog
+* Fri Nov 9 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.b2
+- Removed IPA CA theme package.
+
 * Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.b2
 - Renamed ipa-pki-common-theme to ipa-pki-server-theme.
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 0d2c39d390c7252e66cfc8e8d07da453b85db0f8..6e6bd37cef25771680024c0e1336e7e3a1ce5d7a 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -14,7 +14,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          %{?relprefix}50%{?prerel}%{?dist}
+Release:          %{?relprefix}51%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -389,7 +389,6 @@ Group:            System Environment/Daemons
 BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
-Requires:         pki-ca-theme >= 10.0.0
 Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
@@ -437,7 +436,6 @@ Group:            System Environment/Daemons
 BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
-Requires:         pki-kra-theme >= 10.0.0
 Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
@@ -491,7 +489,6 @@ Group:            System Environment/Daemons
 BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
-Requires:         pki-ocsp-theme >= 10.0.0
 Requires:         pki-server = %{version}-%{release}
 %if 0%{?fedora} >= 16
 Requires(post):   systemd-units
@@ -552,7 +549,6 @@ Group:            System Environment/Daemons
 BuildArch:        noarch
 
 Requires:         java >= 1:1.6.0
-Requires:         pki-tks-theme >= 10.0.0
 Requires:         pki-server = %{version}-%{release}
 Requires:         pki-symkey = %{version}-%{release}
 %if 0%{?fedora} >= 16
@@ -1273,6 +1269,9 @@ fi
 
 
 %changelog
+* Fri Nov 9 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.51.b2
+- Removed dependency on CA, KRA, OCSP, TKS theme packages.
+
 * Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.50.b2
 - Renamed pki-common-theme to pki-server-theme.
 
-- 
1.7.12.1